#include <bits/stdc++.h>

using namespace std;
#define ll long long

void bfs(int u, vector<vector<int> > &g, vector<int> &h, vector<int> &s, int l) {
    s[u] = l;
    for (auto v : g[u]) {
        if (s[v] > l + 1) {
            s[v] = l + 1;
            bfs(v, g, h, s, l + 1);
        }
    }
}

int main() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<int> > g(n);
    while (m--) {
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }
    vector<int> h(n, -1);
    for (int i = 0; i < k; i++) {
        int x, y;
        cin >> x >> y;
        h[x - 1] = y;
    }
    vector<int> t;
    for (int i = 0; i < n; i++) {
        vector<int> s(n, 1e6);
        bfs(i, g, h, s, 0);
        for (int j = 0; j < n; j++) {
            if (s[j] <= h[j]) {
                t.push_back(i);
                break;
            }
        }
    }
    sort(t.begin(), t.end());
    cout << t.size() << endl;
    for (auto i : t) {
        cout << i + 1 << ' ';
    }
    return 0;
}
