#include <bits/stdc++.h>

using namespace std;
#define ll long long
set<int> solve;
void bfs(int u, vector<vector<int> > &g, int l) {
    if (l == -1) {
        return;
    }
    solve.insert(u);
    for (auto v : g[u]) {
        if (solve.count(v) == 0) {
            bfs(v, g, l - 1);
        }
    }
}

int main() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<int> > g(n);
    while (m--) {
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }
    vector<pair<int, int> > ph(k);
    for (int i = 0; i < k; i++) {
        int p, h;
        cin >> p >> h;
        ph[i] = {p - 1, h};
    }
    for (int i = 0; i < k; i++) {
        bfs(ph[i].first, g, ph[i].second);
    }
    cout << solve.size() << endl;
    for (auto i : solve) {
        cout << i + 1 << ' ';
    }
    return 0;
}