#include <bits/stdc++.h>

using namespace std;
#define ll long long
void bfs(int u, vector<vector<int> > &g, vector<int> &s, int l) {
    if (l == -1) {
        return;
    }
    s[u] = l;
    for (auto v : g[u]) {
        if (s[v] < l - 1) {
            bfs(v, g, s, l - 1);
        }
    }
}

int main() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<int> > g(n);
    while (m--) {
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }
    vector<pair<int, int> > ph(k);
    for (int i = 0; i < k; i++) {
        int p, h;
        cin >> p >> h;
        ph[i] = {p - 1, h};
    }
    sort(ph.begin(), ph.end(), [](pair<int, int> a, pair<int, int> b) {
        return a.second > b.second;
    });
    vector<int> s(n, -1);
    for (int i = 0; i < k; i++) {
        bfs(ph[i].first, g, s, ph[i].second);
    }
    vector<int> solve;
    for (int i = 0; i < n; i++) {
        if (s[i] != -1) {
            solve.push_back(i);
        }
    }
    cout << solve.size() << endl;
    for (auto i : solve) {
        cout << i + 1 << ' ';
    }
    return 0;
}