#include <bits/stdc++.h>

using namespace std;
#define ll long long
vector<int> s;
vector<vector<int> > g;
void bfs(int u, int l) {
    if (s[u] >= l) {
        return;
    }
    s[u] = l;
    if (l == 0) {
        return;
    }
    for (auto v : g[u]) {
        bfs(v, l - 1);
    }
}

int main() {
    int n, m, k;
    cin >> n >> m >> k;
    s.resize(n, -1);
    g.resize(n, {});
    while (m--) {
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }
    vector<pair<int, int> > ph(k);
    for (int i = 0; i < k; i++) {
        int p, h;
        cin >> p >> h;
        ph[i] = {p - 1, h};
    }
    sort(ph.begin(), ph.end(), [](pair<int, int> a, pair<int, int> b) {
        return a.second > b.second;
    });
    for (int i = 0; i < k; i++) {
        bfs(ph[i].first, ph[i].second);
    }
    vector<int> solve;
    for (int i = 0; i < n; i++) {
        if (s[i] != -1) {
            solve.push_back(i);
        }
    }
    if (solve.size() == 0) {
        cout << ' ';
        return 0;
    }
    cout << solve.size() << endl;
    for (auto i : solve) {
        cout << i + 1 << ' ';
    }
    return 0;
}