#include <bits/stdc++.h>

using namespace std;
#define ll long long
vector<int> s;
vector<vector<int> > g;
vector<int> ph;
void bfs(int u, int l, int p) {
    if (ph[u] < l) {
        ph[u] = 0;
    }
    s[u] = l;
    if (l == 0) {
        return;
    }
    for (auto v : g[u]) {
        if (v != p && s[v] >= l + 1) {
            continue;
        }
        if (s[v] < l - 1) {
            bfs(v, l - 1, u);
        }
    }
}

int main() {
    int n, m, k;
    cin >> n >> m >> k;
    s.resize(n, -1);
    g.resize(n);
    ph.resize(n, 0);
    while (m--) {
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }
    for (int i = 0; i < k; i++) {
        int p, h;
        cin >> p >> h;
        ph[p - 1] = h;
    }
    for (int i = 0; i < n; i++) {
        if (ph[i] != 0) {
            bfs(i, ph[i], -1);
        }
    }
    vector<int> solve;
    for (int i = 0; i < n; i++) {
        if (s[i] != -1) {
            solve.push_back(i);
        }
    }
    if (solve.size() == 0) {
        cout << ' ';
        return 0;
    }
    cout << solve.size() << endl;
    for (auto i : solve) {
        cout << i + 1 << ' ';
    }
    return 0;
}